<?php

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0]) || isset($_SERVER['REQUEST_METHOD'])  || isset($_SERVER['REMOTE_ADDR'])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;
if (isset($config)) {
	include_once(dirname(__FILE__) . "/../lib/snmp.php");
}

if (!isset($called_by_script_server)) {
	include_once(dirname(__FILE__) . "/../include/global.php");
	include_once(dirname(__FILE__) . "/../lib/snmp.php");

	array_shift($_SERVER["argv"]);

	error_reporting(1);
	print call_user_func_array("ss_nbar_all", $_SERVER["argv"]);
}

function ss_nbar_all($hostname, $host_id,$snmp_auth, $cmd, $arg, $index) {
	// add ifindex to these oids.
	// enable = 1 (yes) or 2 (no)
	// uptime = value of sysuptime when enabled

	$oids = array(
		"enable" => ".1.3.6.1.4.1.9.9.244.1.1.1.1.1",
		"uptime" => ".1.3.6.1.4.1.9.9.244.1.1.1.1.2",
		"protos" => ".1.3.6.1.4.1.9.9.244.1.8.1.1.2"
		);

	// Add .ifindex.protocol to theses oids:-
	$nbaroids = array(
		"protoname"	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.2",
		"inpkts" 	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.3",
		"outpkts" 	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.4",
		"inbytes" 	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.5",
		"outbytes" 	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.6",
		"hcinpkts" 	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.7",
		"hcoutpkts" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.8",
		"hcinbytes" => ".1.3.6.1.4.1.9.9.244.1.2.1.1.9",
		"hcoutbytes"=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.10",
		"inbitrate"	=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.11",
		"outbitrate"=> ".1.3.6.1.4.1.9.9.244.1.2.1.1.12"
		);

	// interface mib oids
	// add ifindex
	$ifoids = array(
		"ifIndex" 		=> ".1.3.6.1.2.1.2.2.1.1",
		"ifDescr" 		=> ".1.3.6.1.2.1.2.2.1.2",
		"ifType" 		=> ".1.3.6.1.2.1.2.2.1.3",
		"ifAdminStatus" => ".1.3.6.1.2.1.2.2.1.7",
		"ifOperStatus" 	=> ".1.3.6.1.2.1.2.2.1.8",
		"ifName" 		=> ".1.3.6.1.2.1.31.1.1.1.1",
		"ifAlias" 		=> ".1.3.6.1.2.1.31.1.1.1.18"
		);

	/* support for SNMP V2 and SNMP V3 parameters */
	$snmp = explode(":", $snmp_auth);
	$snmp_version   = $snmp[0];
	$snmp_port      = $snmp[1];
	$snmp_timeout   = $snmp[2];
	$ping_retries   = $snmp[3];
	$max_oids       = $snmp[4];

	$snmp_auth_username     = "";
	$snmp_auth_password     = "";
	$snmp_auth_protocol     = "";
	$snmp_priv_passphrase   = "";
	$snmp_priv_protocol     = "";
	$snmp_context           = "";
	$snmp_community         = "";

	if ($snmp_version == 3) {
		$snmp_auth_username   = $snmp[6];
		$snmp_auth_password   = $snmp[7];
		$snmp_auth_protocol   = $snmp[8];
		$snmp_priv_passphrase = $snmp[9];
		$snmp_priv_protocol   = $snmp[10];
	} else {
		$snmp_community = $snmp[5];
	}


	/* support just to query defined protocols  or "ALL" to disable */

//	$protocols = array("unknown","http","secure-http","microsoftds","ipinip","snmp","rtp","notes","exchange","dns","ftp","h323","skype","rtcp");
	$protocols = array("ALL");

/*
* process INDEX requests
*/
if ($cmd == "index") {
	$arr_index = ss_nbar_get_indexes($protocols, $oids, $nbaroids, $ifoids, $hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $environ=SNMP_POLLER);

	for ($i=0;($i<sizeof($arr_index));$i++) {
		print $arr_index[$i] . "\n";
	}

/*
* process QUERY requests
*/
}elseif ($cmd == "query") {
	//$arg = $_SERVER["argv"][5];


	$arr_index = ss_nbar_get_indexes($protocols, $oids, $nbaroids, $ifoids, $hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $environ=SNMP_POLLER);



	switch ($arg) {
		case 'index':
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr_index[$i] . "\n";
		}
		break;
		case 'protoindex':
		case 'protoname':
		case 'inpkts':
		case 'outpkts':
		case 'inbytes':
		case 'outbytes':
		case 'hcinpkts':
		case 'hcoutpkts':
		case 'hcinbytes':
		case 'hcoutbytes':
		case 'inbitrate':
		case 'outbitrate':
		$arr = ss_nbar_get_info($oids, $nbaroids, $ifoids, $arr_index,$hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $arg);
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr[$i] . "\n";
		}
		break;
		case 'ifName':
		case 'ifDescr':
		case 'ifType':
		case 'ifAlias':
		case 'ifAdminStatus':
		case 'ifOperStatus':
		$arr = ss_nbar_get_ifinfo($oids, $nbaroids, $ifoids, $arr_index, $hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $arg);
		for ($i=0;($i<sizeof($arr_index));$i++) {
			print $arr_index[$i] . "!" . $arr[$i] . "\n";
		}
		break;
	}

/*
* process GET requests
*/
}elseif ($cmd == "get") {

	switch ($arg) {
		case 'index':
		return $index;
		break;
		case 'protoname':
		case 'inpkts':
		case 'outpkts':
		case 'inbytes':
		case 'outbytes':
		case 'hcinpkts':
		case 'hcoutpkts':
		case 'hcinbytes':
		case 'hcoutbytes':
		case 'inbitrate':
		case 'outbitrate':
		$t_oid = $nbaroids[$arg].".".strval($index);
		return  cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);
		break;
		case 'ifName':
		case 'ifDescr':
		case 'ifType':
		case 'ifAlias':
		case 'ifAdminStatus':
		case 'ifOperStatus':
		$temp = explode(".",$index);
		$t_oid = $ifoids[$arg].".".$temp[0];
		return  cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);
		break;

	}
}
}
// Get Specific Info for ISDN Index from ifIndex

function ss_nbar_get_ifinfo(&$oids, &$nbaroids, &$ifoids, &$arr_index, $hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $arg) {

	global $config;

	$return_arr = array();

	// Cycle Custom Index and return reqd argument..'
	for ($i=0;($i<sizeof($arr_index));$i++) {
		// build oid
		$temp = explode(".",$arr_index[$i]);
		$t_oid = $ifoids[$arg].".".strval($temp[0]);
		$return_arr[$i] =  cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);
	}

	return $return_arr;
}


function ss_nbar_get_info($oids, $nbaroids, $ifoids, $arr_index,$hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $arg) {
	global $config;

	$return_arr = array();

	// Cycle Custom Index and return reqd argument..'
	for ($i=0;($i<sizeof($arr_index));$i++) {
		// build oid
		$t_oid = $nbaroids[$arg].".".strval($arr_index[$i]);
		$return_arr[$i] =  cacti_snmp_get($hostname, $snmp_community, $t_oid, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);
	}




	return $return_arr;
}

function ss_nbar_get_indexes($protocols, $oids, $nbaroids, $ifoids, $hostname, $snmp_community, $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, $max_oids, $environ=SNMP_POLLER) {

	global $config;

	$return_arr = array();

	//	1st we walk the enable to table to find enabled interfaces

	$walkit = cacti_snmp_walk($hostname, $snmp_community, $oids["enable"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $snmp_port, $snmp_timeout, $ping_retries, SNMP_POLLER);

	$arr = ss_nbar_reindex($walkit);

	$walkit = cacti_snmp_walk($hostname, $snmp_community, $oids["protos"], $snmp_version, $snmp_auth_username, $snmp_auth_password, $snmp_auth_protocol, $snmp_priv_passphrase,$snmp_priv_protocol,$snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);

	$arr_proto = ss_nbar_reindex($walkit);
	$arr_proto_index = ss_nbar_reindex_2($walkit);




	$index_count = 0;

	if ($protocols[0] != "ALL"){

	for ($k=0;($k<sizeof($protocols));$k++) {
		for ($i=0;($i<sizeof($arr));$i++) {
			$test = cacti_snmp_get($hostname, $snmp_community, $ifoids["ifIndex"].".".($i+1), $snmp_version, $snmp_auth_username,$snmp_auth_password,$snmp_auth_protocol,$snmp_priv_passphrase,$snmp_priv_protocol,$snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);
			if ((strpos($arr[$i], "1") !== FALSE) and (strpos($test,"OID") == FALSE)) {
				for ($j=0;($j<sizeof($arr_proto));$j++) {
					if ($arr_proto[$j] == $protocols[$k]){
						$temp = explode(".",$arr_proto_index[$j]);
						$return_arr[$index_count] = strval($i+1).".".$temp[sizeof($temp)-1];
						$index_count++;
						break;
					}
				}
			}
		}
	}
	}
	else{
                for ($i=0;($i<sizeof($arr));$i++) {
			$test = cacti_snmp_get($hostname, $snmp_community, $ifoids["ifIndex"].".".($i+1), $snmp_version, $snmp_auth_username,$snmp_auth_password,$snmp_auth_protocol,$snmp_priv_passphrase,$snmp_priv_protocol,$snmp_context,$snmp_port,$snmp_timeout, $ping_retries, SNMP_POLLER);
                        if ((strpos($arr[$i], "1") !== FALSE) and (strpos($test,"OID") == FALSE)) {
                                for ($j=0;($j<sizeof($arr_proto));$j++) {
                                        $temp = explode(".",$arr_proto_index[$j]);
                                        $return_arr[$index_count] = strval($i+1).".".$temp[sizeof($temp)-1];
                                        $index_count++;
                                }
                        }
                }


	}




	return $return_arr;
}

function ss_nbar_reindex($arr) {
	$return_arr = array();
	for ($i=0;($i<sizeof($arr));$i++) {
		$return_arr[$i] = $arr[$i]["value"];
	}

	return $return_arr;
}

function ss_nbar_reindex_2($arr) {
        $return_arr = array();
        for ($i=0;($i<sizeof($arr));$i++) {
                $return_arr[$i] = $arr[$i]["oid"];
        }

        return $return_arr;
}

?>

